unit ReRun;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TReRun = class(TComponent)
  private
    FormAOwner:TForm;
    FormOldClose:TCloseEvent;
    FormOldShow: TNotifyEvent;
    procedure LaFormClose(Sender: TObject; var Action: TCloseAction);
    procedure LaFormShow(sender: TObject);
  protected
    { Dclarations protges }
  public
     Constructor Create(AOwner:TComponent); override;
  published
    { Dclarations publies }
  end;

procedure Register;



implementation
Uses Registry;

procedure MetEnAutoRun;
{met ce qu'il faut dans la base de registre pour que le programme se mette en AutoRun}
{pour comprendre, voir les autres exemples de la base de registre}
Var Registre:TRegistry;
begin
    Registre:=TRegistry.Create;
    Registre.RootKey:=HKEY_LOCAL_MACHINE;
    if Registre.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', false)
      then Registre.WriteString(ExtractFileName(Application.ExeName),Application.ExeName);
    Registre.Free;
end;


Procedure AnnuleAutorun;
{annule le fait que le programme soit en AutoRun}
Var Registre:TRegistry;
begin
    Registre:=TRegistry.Create;
    Registre.RootKey:=HKEY_LOCAL_MACHINE;
    if Registre.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', false)
           then Registre.DeleteValue(ExtractFileName(Application.ExeName));
    Registre.Free;
end;

Constructor TReRun.Create(AOwner:TComponent);
begin
  Inherited create(AOwner);
  if not (csDesigning in ComponentState) then //si on est pas en mode conception
  begin
    FormAOwner:=TForm(AOwner); //FormAOwner pointera ainsi sur la forme principale de notre projet
    FormOldShow:=FormAOwner.OnShow; // sauvegarde de l'vnement OnShow dans FormOldShow
    FormOldClose:=FormAOwner.OnClose; //FormOldClose pointe ainsi sur l'vnement OnClose de la Forme qui contient ce composant
    FormAOwner.OnShow:=LaFormShow; // on redirige l'vnement OnShow vers LaFormShow
    FormAOwner.OnClose:=LaFormClose;  //Ainsi, La procdure LaFormClose sera dclenche lors d'un vnement OnClose de la Forme qui contient ce composant
  end;
end;

procedure TReRun.LaFormClose(Sender: TObject; var Action: TCloseAction);
begin
  if assigned(FormOldClose)then FormOldClose(Sender,Action);
  AnnuleAutoRun;//ainsi, si on passe par une procdure de type close pour fermer l'application, on annule l'Autorun.
                // si on ferme Windows alors que l'application est ouverte, le programme ne passe pas par un close.
end;

procedure TReRun.LaFormShow(sender: TObject);
begin
  If assigned(FormOldShow) then FormOldShow(sender);
    MetEnAutorun; // On met le projet en AutoRun.
end;

procedure Register;
begin
  RegisterComponents('Perso', [TReRun]);
end;

end.
 